(* $Id: gont.ml,v 1.19 2001/11/15 22:34:33 malekith Exp $ *)

open Gontutil

let compile prefix in_name out_name =
  let compile_decl decl =
    Gontbind.bind decl;
    Gonttypes.typecheck_decl decl;
    Gontcodegen.ksi_code decl in
  let in_ch = if in_name = "-" then stdin else open_in in_name in
  let out_ch = if out_name = "-" then stdout else open_out out_name in
  let close_files () =
     if out_ch != stdout then close_out out_ch else ();
     if in_ch != stdin then close_in in_ch else () in
  try
    let lexbuf = Lexing.from_channel in_ch in
    Ksi.read_target_conf prefix;
    Ksi.output_header out_ch;
    List.iter (Ksi.output_decl out_ch) (Gontcodegen.ksi_runtime_proto ());
    Lexer.set_file_name in_name;
    while true do
      let decl = 
        try 
          (Parser.decl Lexer.token lexbuf) 
        with 
          Parsing.Parse_error -> 
            raise(Syntax_error ((Lexer.get_current_location ()), 
                                "parse error"))
      in
      List.iter (Ksi.output_decl out_ch) (compile_decl decl)
    done;
    assert false
  with 
      Eof -> 
        Ksi.output_trailer out_ch;
        close_files ();
        0
    | Syntax_error(loc, msg) ->
        close_files ();
        err_msg (loc, msg);
        1
    | x ->
        close_files ();
        prerr_endline ("Unhandled exception: " ^ (Printexc.to_string x));
        1
;;
